#ifndef CONSOLEVIEW_H_INCLUDED
#define CONSOLEVIEW_H_INCLUDED

#include <QLineEdit>
#include <QTextEdit>

#include "compat.h"
#include "Common.h"
#include "emubase/Emubase.h"

class MainWindow;

class ConsoleView: public QWidget {
  Q_OBJECT
public:
  ConsoleView( MainWindow *mainWindow, QWidget *parent = 0 );
  void Step();

protected:
  QTextEdit *consoleTE;
  QLineEdit *consoleLE;
  MainWindow *mainWindow;

  BOOL m_okCurrentProc;

  CProcessor* GetCurrentProcessor();
  void Print( const QString& message );
  void ClearConsole();
  void PrintConsolePrompt();
  void PrintRegister( QString strName, WORD value );
  void SaveMemoryDump( CProcessor *pProc );
  void PrintMemoryDump( CProcessor* pProc, WORD address, int lines );
  void PrintDisassemble(CProcessor* pProc, WORD address, BOOL okOneInstr);
  void ShowHelp();

protected slots:
  void DoConsoleCommand();
};

#endif // CONSOLEVIEW_H_INCLUDED
