#include <QApplication>
#include <QMainWindow>

#include "Common.h"
#include "Emulator.h"
#include "UKNCBTL.h"
#include "MainWindow.h"

static MainWindow *mainWindow;

void MainWindow_UpdateAllViews() {
  if ( mainWindow ) mainWindow->updateAllViews();
}

void MainWindow_UpdateMenu() {
  if ( mainWindow ) mainWindow->updateMenu();
}

int main( int argc, char **argv ) {
  QApplication qa( argc, argv );
  qa.setOrganizationName( "vr5" );
  qa.setApplicationName( "UKNCEverywhere" );

  if (!InitEmulator()) return FALSE;

  MainWindow w;
  mainWindow = &w;

  if ( Settings_GetAutostart() ) {
	Emulator_Start();
	w.updateMenu();
  }

  while ( !w.isHidden() ) {
	if ( g_okEmulatorRunning && Emulator_SystemFrame( w.screenView() ) )
		w.systemFrame();

	QApplication::processEvents();
  }

  return 0;
}
